// SPDX-License-Identifier: Unlicense

#ifndef MANIFEST_H
#define MANIFEST_H

#include "type.h"

#include <vector>
#include <string>

struct Tuning
{
  i8 string[8]{ -128, -128, -128, -128, -128, -128, -128, -128 };
};

namespace Manifest
{
  struct Info
  {
    std::u8string persistentId;
    std::u8string arrangementName;

    bool isBass{};
    bool bassPick{};
    i8 capoFret{};
    f32 centOffset{};
    std::u8string manifestUrn;
    Tuning tuning{};
  };

  std::vector<Manifest::Info> readPsarcHsan(const std::vector<u8>& hsanData, std::u8string& artistName, std::u8string& songName, std::u8string& albumName, i32& songYear, TimeNS& songLengthNS);
}

#endif // MANIFEST_H
