// SPDX-License-Identifier: Unlicense

#ifndef SFX_H
#define SFX_H

#include "typedefs.h"

#ifdef SHR3D_SFX

#include "type.h"

#include <string>
#include <vector>

struct Rect;

namespace Sfx
{
  extern std::vector<std::u8string> names;

  SfxType type(i32 index);
  const char8_t* index2typeName(i32 index);
  //SfxType typeName2type(const std::u8string& typeName);
  //i32 type2MinIndex(SfxType sfxType);
  i32 typeName2indexBegin(const std::u8string& typeName);
  i32 indexBegin2indexEnd(i32 minIndex);

  void init();

#ifdef SHR3D_SFX_PLUGIN_GUI_WINDOW
  bool hasWindow(i32 index);
  void openWindow(i32 index, i32 instance);
  Size getWindowSize(i32 index, i32 instance);
  void moveWindow(i32 index, i32 instance, i32 x, i32 y);
  void closeWindow(i32 index, i32 instance);
#endif // SHR3D_SFX_PLUGIN_GUI_WINDOW

#ifdef SHR3D_SFX_PLUGIN
  i32 numParams(i32 index, i32 instance);
  void getParameterProperties(i32 index, i32 instance, i32 param, SfxParameterProperties& parameterProperties);
  f32 getParameter(i32 index, i32 instance, i32 param);
  void setParameter(i32 index, i32 instance, i32 param, f32 value);
#endif // SHR3D_SFX_PLUGIN

  bool processBlock(i32 index, i32 instance, f32** inBlock, f32** outBlock, i32 blockSize);

  std::u8string saveParameters(i32 index, i32 instance);
  void loadParameters(i32 index, i32 instance, const std::u8string& parameters);
}

#endif // SHR3D_SFX

#endif // SFX_H
