/* ========================================
 *  AtmosphereBuss - AtmosphereBuss.h
 *  Created 8/12/11 by SPIAdmin 
 *  Copyright (c) 2011 __MyCompanyName__, Airwindows uses the MIT license
 * ======================================== */

#ifndef __AtmosphereBuss_AtmosphereBuss_H
#define __AtmosphereBuss_AtmosphereBuss_H

#include "../../../configuration.h"
#ifdef SHR3D_SFX_CORE_AIRWINDOWS

#include "../common/airwin_consolidated_base.h"


namespace airwinconsolidated::AtmosphereBuss {
enum {
	kParamA = 0,
  kNumParameters = 1
}; //


class AtmosphereBuss final : public AirwinConsolidatedBase
{
public:
    AtmosphereBuss();
    ~AtmosphereBuss();
    void processReplacing (float** inputs, float** outputs, VstInt32 sampleFrames) override;
    float getParameter(VstInt32 index) override;
    void setParameter(VstInt32 index, float value) override;
    void getParameterLabel(VstInt32 index, char *text) override;
    void getParameterName(VstInt32 index, char *text) override;
    void getParameterDisplay(VstInt32 index, char *text) override;
private:
    char _programName[kVstMaxProgNameLen + 1];
    
	double gainchase;
	double settingchase;
	double chasespeed;		
	
	uint32_t fpdL;
	uint32_t fpdR;
	double fpNShapeL;
	double lastSampleAL;
	double lastSampleBL;
	double lastSampleCL;
	double lastSampleDL;
	double lastSampleEL;
	double lastSampleFL;
	double lastSampleGL;
	double lastSampleHL;
	double lastSampleIL;
	double lastSampleJL;
	double lastSampleKL;
	double lastSampleLL;
	double lastSampleML;
	
	double fpNShapeR;
	double lastSampleAR;
	double lastSampleBR;
	double lastSampleCR;
	double lastSampleDR;
	double lastSampleER;
	double lastSampleFR;
	double lastSampleGR;
	double lastSampleHR;
	double lastSampleIR;
	double lastSampleJR;
	double lastSampleKR;
	double lastSampleLR;
	double lastSampleMR;
	
	double thresholdA;
	double thresholdB;
	double thresholdC;
	double thresholdD;
	double thresholdE;
	double thresholdF;
	double thresholdG;
	double thresholdH;
	double thresholdI;
	double thresholdJ;
	double thresholdK;
	double thresholdL;
	double thresholdM;
	
    float A;
};

} // end namespace

#endif // SHR3D_SFX_CORE_AIRWINDOWS

#endif
