/* ========================================
 *  Biquad - Biquad.h
 *  Created 8/12/11 by SPIAdmin 
 *  Copyright (c) 2011 __MyCompanyName__, Airwindows uses the MIT license
 * ======================================== */

#ifndef __Biquad_Biquad_H
#define __Biquad_Biquad_H

#include "../../../configuration.h"
#ifdef SHR3D_SFX_CORE_AIRWINDOWS

#include "../common/airwin_consolidated_base.h"


namespace airwinconsolidated::Biquad {
enum {
	kParamA = 0,
	kParamB = 1,
	kParamC = 2,
	kParamD = 3,
  kNumParameters = 4
}; //


class Biquad final : public AirwinConsolidatedBase
{
public:
    Biquad();
    ~Biquad();
    void processReplacing (float** inputs, float** outputs, VstInt32 sampleFrames) override;
    float getParameter(VstInt32 index) override;
    void setParameter(VstInt32 index, float value) override;
    void getParameterLabel(VstInt32 index, char *text) override;
    void getParameterName(VstInt32 index, char *text) override;
    void getParameterDisplay(VstInt32 index, char *text) override;
private:
    char _programName[kVstMaxProgNameLen + 1];
    
	double biquad[11]; //note that this stereo form doesn't require L and R forms!
	//This is because so much of it is coefficients etc. that are the same on both channels.
	//So the stored samples are in 7-8 and 9-10, and freq/res/coefficients serve both.
	
	uint32_t fpdL;
	uint32_t fpdR;
	//default stuff

    float A;
    float B;
    float C;
    float D;
};

} // end namespace

#endif // SHR3D_SFX_CORE_AIRWINDOWS

#endif
