/* ========================================
 *  Channel5 - Channel5.h
 *  Created 8/12/11 by SPIAdmin 
 *  Copyright (c) 2011 __MyCompanyName__, Airwindows uses the MIT license
 * ======================================== */

#ifndef __Channel5_Channel5_H
#define __Channel5_Channel5_H

#include "../../../configuration.h"
#ifdef SHR3D_SFX_CORE_AIRWINDOWS

#include "../common/airwin_consolidated_base.h"


namespace airwinconsolidated::Channel5 {
enum {
	kParamA = 0,
	kParamB = 1,
	kParamC = 2,
  kNumParameters = 3
}; //


class Channel5 final : public AirwinConsolidatedBase
{
public:
    Channel5();
    ~Channel5();
    void processReplacing (float** inputs, float** outputs, VstInt32 sampleFrames) override;
    float getParameter(VstInt32 index) override;
    void setParameter(VstInt32 index, float value) override;
    void getParameterLabel(VstInt32 index, char *text) override;
    void getParameterName(VstInt32 index, char *text) override;
    void getParameterDisplay(VstInt32 index, char *text) override;
private:
    char _programName[kVstMaxProgNameLen + 1];
    
	double fpNShapeL;
	double fpNShapeR;
	bool fpFlip;
	//default stuff
	double iirSampleLA;
	double iirSampleRA;
	double iirSampleLB;
	double iirSampleRB;
	double lastSampleL;
	double lastSampleR;
	double iirAmount;
	double threshold;
	
    float consoletype;
    float drive; //parameters. Always 0-1, and we scale/alter them elsewhere.
	float output;
};

} // end namespace

#endif // SHR3D_SFX_CORE_AIRWINDOWS

#endif