/* ========================================
 *  Console8LiteBuss - Console8LiteBuss.h
 *  Created 8/12/11 by SPIAdmin 
 *  Copyright (c) Airwindows, Airwindows uses the MIT license
 * ======================================== */

#ifndef __Console8LiteBuss_Console8LiteBuss_H
#define __Console8LiteBuss_Console8LiteBuss_H

#include "../../../configuration.h"
#ifdef SHR3D_SFX_CORE_AIRWINDOWS

#include "../common/airwin_consolidated_base.h"


namespace airwinconsolidated::Console8LiteBuss {
enum {
	kParamA = 0,
  kNumParameters = 1
}; //


class Console8LiteBuss final : public AirwinConsolidatedBase
{
public:
    Console8LiteBuss();
    ~Console8LiteBuss();
    void processReplacing (float** inputs, float** outputs, VstInt32 sampleFrames) override;
    float getParameter(VstInt32 index) override;
    void setParameter(VstInt32 index, float value) override;
    void getParameterLabel(VstInt32 index, char *text) override;
    void getParameterName(VstInt32 index, char *text) override;
    void getParameterDisplay(VstInt32 index, char *text) override;
private:
    char _programName[kVstMaxProgNameLen + 1];
    	
	double iirAL;
	double iirBL;
	double iirAR;
	double iirBR;
	bool hsr;
	enum {
		fix_freq,
		fix_reso,
		fix_a0,
		fix_a1,
		fix_a2,
		fix_b1,
		fix_b2,
		fix_sL1,
		fix_sL2,
		fix_sR1,
		fix_sR2,
		fix_total
	}; //fixed frequency biquad filter for ultrasonics, stereo
	double fix[fix_total];
	double fixB[fix_total];
	double softL[11];
	double softR[11];
	int cycleEnd;
	
	double inTrimA;
	double inTrimB;
	double lastSampleL;
	double intermediateL[18];
	bool wasPosClipL;
	bool wasNegClipL; //ClipOnly2
	double lastSampleR;
	double intermediateR[18];
	bool wasPosClipR;
	bool wasNegClipR;
	int spacing;	
	
	uint32_t fpdL;
	uint32_t fpdR;
	//default stuff

    float A;
};

} // end namespace

#endif // SHR3D_SFX_CORE_AIRWINDOWS

#endif
