/* ========================================
 *  FathomFive - FathomFive.h
 *  Created 8/12/11 by SPIAdmin 
 *  Copyright (c) 2011 __MyCompanyName__, Airwindows uses the MIT license
 * ======================================== */

#ifndef __FathomFive_FathomFive_H
#define __FathomFive_FathomFive_H

#include "../../../configuration.h"
#ifdef SHR3D_SFX_CORE_AIRWINDOWS

#include "../common/airwin_consolidated_base.h"


namespace airwinconsolidated::FathomFive {
enum {
	kParamA = 0,
	kParamB = 1,
	kParamC = 2,
	kParamD = 3,
  kNumParameters = 4
}; //

const int kNumPrograms = 1;

class FathomFive final : public AirwinConsolidatedBase
{
public:
    FathomFive();
    ~FathomFive();
    void processReplacing (float** inputs, float** outputs, VstInt32 sampleFrames) override;
	virtual float getParameter(VstInt32 index);                   // get the parameter value at the specified index
    void setParameter(VstInt32 index, float value) override;
    void getParameterLabel(VstInt32 index, char *text) override;
    void getParameterName(VstInt32 index, char *text) override;
    void getParameterDisplay(VstInt32 index, char *text) override;
private:
    char _programName[kVstMaxProgNameLen + 1];
    	
	bool WasNegativeL;
	bool SubOctaveL;
	double iirSampleLA;
	double iirSampleLB;
	double iirSampleLC;
	double iirSampleLD;

	bool WasNegativeR;
	bool SubOctaveR;
	double iirSampleRA;
	double iirSampleRB;
	double iirSampleRC;
	double iirSampleRD;
	
    float A; //Root Note
    float B; //SubOctave
    float C; //Frequency
    float D; //Dry/Wet
	//parameters. Always 0-1, and we scale/alter them elsewhere.
	uint32_t fpdL;
	uint32_t fpdR;
};

} // end namespace

#endif // SHR3D_SFX_CORE_AIRWINDOWS

#endif
