/* ========================================
 *  FinalClip - FinalClip.h
 *  Created 8/12/11 by SPIAdmin 
 *  Copyright (c) Airwindows, Airwindows uses the MIT license
 * ======================================== */

#ifndef __FinalClip_FinalClip_H
#define __FinalClip_FinalClip_H

#include "../../../configuration.h"
#ifdef SHR3D_SFX_CORE_AIRWINDOWS

#include "../common/airwin_consolidated_base.h"


namespace airwinconsolidated::FinalClip {
enum {
  kNumParameters = 0
}; //


class FinalClip final : public AirwinConsolidatedBase
{
public:
    FinalClip();
    ~FinalClip();
    void processReplacing (float** inputs, float** outputs, VstInt32 sampleFrames) override;
    float getParameter(VstInt32 index) override;
    void setParameter(VstInt32 index, float value) override;
    void getParameterLabel(VstInt32 index, char *text) override;
    void getParameterName(VstInt32 index, char *text) override;
    void getParameterDisplay(VstInt32 index, char *text) override;
private:
    char _programName[kVstMaxProgNameLen + 1];
    
	double lastSampleL;
	double intermediateL[16];
	bool wasPosClipL;
	bool wasNegClipL;
	double lastSampleR;
	double intermediateR[16];
	bool wasPosClipR;
	bool wasNegClipR; //Stereo ClipOnly2
	
	//uint32_t fpdL;
	//uint32_t fpdR; //leave off
	//default stuff
	
};

} // end namespace

#endif // SHR3D_SFX_CORE_AIRWINDOWS

#endif
