/* ========================================
 *  PDBuss - PDBuss.h
 *  Created 8/12/11 by SPIAdmin 
 *  Copyright (c) 2011 __MyCompanyName__, Airwindows uses the MIT license
 * ======================================== */

#ifndef __PDBuss_PDBuss_H
#define __PDBuss_PDBuss_H

#include "../../../configuration.h"
#ifdef SHR3D_SFX_CORE_AIRWINDOWS

#include "../common/airwin_consolidated_base.h"


namespace airwinconsolidated::PDBuss {
enum {
	kParamA = 0,
	kParamB = 1,
  kNumParameters = 2
}; //


class PDBuss final : public AirwinConsolidatedBase
{
public:
    PDBuss();
    ~PDBuss();
    void processReplacing (float** inputs, float** outputs, VstInt32 sampleFrames) override;
    float getParameter(VstInt32 index) override;
    void setParameter(VstInt32 index, float value) override;
    void getParameterLabel(VstInt32 index, char *text) override;
    void getParameterName(VstInt32 index, char *text) override;
    void getParameterDisplay(VstInt32 index, char *text) override;
private:
    char _programName[kVstMaxProgNameLen + 1];
    
	uint32_t fpdL;
	uint32_t fpdR;
	//default stuff
	double gainchase;
	double settingchase;
	double chasespeed;		
	double previousSampleL;
	double previousSampleR;
	

    float A;
    float B;
};

} // end namespace

#endif // SHR3D_SFX_CORE_AIRWINDOWS

#endif
