/* ========================================
 *  PitchDelay - PitchDelay.h
 *  Created 8/12/11 by SPIAdmin 
 *  Copyright (c) 2011 __MyCompanyName__, Airwindows uses the MIT license
 * ======================================== */

#ifndef __PitchDelay_PitchDelay_H
#define __PitchDelay_PitchDelay_H

#include "../../../configuration.h"
#ifdef SHR3D_SFX_CORE_AIRWINDOWS

#include "../common/airwin_consolidated_base.h"


namespace airwinconsolidated::PitchDelay {
enum {
	kParamA = 0,
	kParamB = 1,
	kParamC = 2,
	kParamD = 3,
	kParamE = 4,
	kParamF = 5,
	kNumParameters = 6
}; //


class PitchDelay final : public AirwinConsolidatedBase
{
public:
    PitchDelay();
    ~PitchDelay();
    void processReplacing (float** inputs, float** outputs, VstInt32 sampleFrames) override;
    float getParameter(VstInt32 index) override;
    void setParameter(VstInt32 index, float value) override;
    void getParameterLabel(VstInt32 index, char *text) override;
    void getParameterName(VstInt32 index, char *text) override;
    void getParameterDisplay(VstInt32 index, char *text) override;
private:
    char _programName[kVstMaxProgNameLen + 1];

	
	double dL[88211];
	double prevSampleL;
	double regenSampleL;
	double delayL;
	double sweepL;
	double regenFilterL[9];
	double outFilterL[9];
	double lastRefL[10];
	
	double dR[88211];
	double prevSampleR;
	double regenSampleR;
	double delayR;
	double sweepR;
	double regenFilterR[9];
	double outFilterR[9];
	double lastRefR[10];
	
	int cycle;
	
	uint32_t fpdL;
	uint32_t fpdR;
	//default stuff

    float A;
    float B;
    float C;
    float D;
    float E;
    float F;

};

} // end namespace

#endif // SHR3D_SFX_CORE_AIRWINDOWS

#endif
