/* ========================================
 *  PitchNasty - PitchNasty.h
 *  Created 8/12/11 by SPIAdmin 
 *  Copyright (c) 2011 __MyCompanyName__, Airwindows uses the MIT license
 * ======================================== */

#ifndef __PitchNasty_PitchNasty_H
#define __PitchNasty_PitchNasty_H

#include "../../../configuration.h"
#ifdef SHR3D_SFX_CORE_AIRWINDOWS

#include "../common/airwin_consolidated_base.h"


namespace airwinconsolidated::PitchNasty {
enum {
	kParamA = 0,
	kParamB = 1,
	kParamC = 2,
	kParamD = 3,
	kParamE = 4,
	kParamF = 5,
  kNumParameters = 6
}; //


class PitchNasty final : public AirwinConsolidatedBase
{
public:
    PitchNasty();
    ~PitchNasty();
    void processReplacing (float** inputs, float** outputs, VstInt32 sampleFrames) override;
    float getParameter(VstInt32 index) override;
    void setParameter(VstInt32 index, float value) override;
    void getParameterLabel(VstInt32 index, char *text) override;
    void getParameterName(VstInt32 index, char *text) override;
    void getParameterDisplay(VstInt32 index, char *text) override;
private:
    char _programName[kVstMaxProgNameLen + 1];
    
	double dL[10002];
	double dR[10002];
	int inCount;
	double outCount;
	bool switchTransition;
	double switchAmountL;
	double switchAmountR;
	double feedbackSampleL;
	double feedbackSampleR;
	uint32_t fpdL;
	uint32_t fpdR;
	//default stuff

    float A;
    float B;
    float C;
    float D;
    float E;
    float F; //parameters. Always 0-1, and we scale/alter them elsewhere.
};

} // end namespace

#endif // SHR3D_SFX_CORE_AIRWINDOWS

#endif
