/* ========================================
 *  Preponderant - Preponderant.h
 *  Created 8/12/11 by SPIAdmin 
 *  Copyright (c) 2011 __MyCompanyName__, Airwindows uses the MIT license
 * ======================================== */

#ifndef __Preponderant_Preponderant_H
#define __Preponderant_Preponderant_H

#include "../../../configuration.h"
#ifdef SHR3D_SFX_CORE_AIRWINDOWS

#include "../common/airwin_consolidated_base.h"


namespace airwinconsolidated::Preponderant {
enum {
	kParamA = 0,
	kParamB = 1,
	kParamC = 2,
	kParamD = 3,
	kParamE = 4,
  kNumParameters = 5
}; //


class Preponderant final : public AirwinConsolidatedBase
{
public:
    Preponderant();
    ~Preponderant();
    void processReplacing (float** inputs, float** outputs, VstInt32 sampleFrames) override;
    float getParameter(VstInt32 index) override;
    void setParameter(VstInt32 index, float value) override;
    void getParameterLabel(VstInt32 index, char *text) override;
    void getParameterName(VstInt32 index, char *text) override;
    void getParameterDisplay(VstInt32 index, char *text) override;
private:
    char _programName[kVstMaxProgNameLen + 1];
	
	double biquadA[15];
	double biquadB[15];
	double biquadC[15];
	
	double bassBalanceL;
	double midBalanceL;
	double highBalanceL;
	double bassTrackL;
	double midTrackL;
	double highTrackL;
	double quicknessL;
	
	double bassBalanceR;
	double midBalanceR;
	double highBalanceR;
	double bassTrackR;
	double midTrackR;
	double highTrackR;
	double quicknessR;
	
	uint32_t fpdL;
	uint32_t fpdR;
	//default stuff

    float A;
    float B;
    float C;
    float D;
    float E; //parameters. Always 0-1, and we scale/alter them elsewhere.

};

} // end namespace

#endif // SHR3D_SFX_CORE_AIRWINDOWS

#endif
