/* ========================================
 *  SoftGate - SoftGate.h
 *  Created 8/12/11 by SPIAdmin 
 *  Copyright (c) 2011 __MyCompanyName__, Airwindows uses the MIT license
 * ======================================== */

#ifndef __SoftGate_SoftGate_H
#define __SoftGate_SoftGate_H

#include "../../../configuration.h"
#ifdef SHR3D_SFX_CORE_AIRWINDOWS

#include "../common/airwin_consolidated_base.h"


namespace airwinconsolidated::SoftGate {
enum {
	kParamA = 0,
	kParamB = 1,
	kParamC = 2,
  kNumParameters = 3
}; //


class SoftGate final : public AirwinConsolidatedBase
{
public:
    SoftGate();
    ~SoftGate();
    void processReplacing (float** inputs, float** outputs, VstInt32 sampleFrames) override;
    float getParameter(VstInt32 index) override;
    void setParameter(VstInt32 index, float value) override;
    void getParameterLabel(VstInt32 index, char *text) override;
    void getParameterName(VstInt32 index, char *text) override;
    void getParameterDisplay(VstInt32 index, char *text) override;
private:
    char _programName[kVstMaxProgNameLen + 1];
    
	uint32_t fpdL;
	uint32_t fpdR;
	//default stuff
	double storedL[2];
	double diffL;
	double storedR[2];
	double diffR;
	double gate;

    float A;
    float B;
    float C;

};

} // end namespace

#endif // SHR3D_SFX_CORE_AIRWINDOWS

#endif
