/* ========================================
 *  SurgeTide - SurgeTide.h
 *  Created 8/12/11 by SPIAdmin 
 *  Copyright (c) 2011 __MyCompanyName__, Airwindows uses the MIT license
 * ======================================== */

#ifndef __SurgeTide_SurgeTide_H
#define __SurgeTide_SurgeTide_H

#include "../../../configuration.h"
#ifdef SHR3D_SFX_CORE_AIRWINDOWS

#include "../common/airwin_consolidated_base.h"


namespace airwinconsolidated::SurgeTide {
enum {
	kParamA = 0,
	kParamB = 1,
	kParamC = 2,
  kNumParameters = 3
}; //


class SurgeTide final : public AirwinConsolidatedBase
{
public:
    SurgeTide();
    ~SurgeTide();
    void processReplacing (float** inputs, float** outputs, VstInt32 sampleFrames) override;
    float getParameter(VstInt32 index) override;
    void setParameter(VstInt32 index, float value) override;
    void getParameterLabel(VstInt32 index, char *text) override;
    void getParameterName(VstInt32 index, char *text) override;
    void getParameterDisplay(VstInt32 index, char *text) override;
private:
    char _programName[kVstMaxProgNameLen + 1];
    
	uint32_t fpdL;
	uint32_t fpdR;
	bool flip;
	double chaseA;
	double chaseB;
	double chaseC;
	
    float A;
    float B;
    float C;

};

} // end namespace

#endif // SHR3D_SFX_CORE_AIRWINDOWS

#endif
