/* ========================================
 *  TripleSpread - TripleSpread.h
 *  Created 8/12/11 by SPIAdmin 
 *  Copyright (c) 2011 __MyCompanyName__, Airwindows uses the MIT license
 * ======================================== */

#ifndef __TripleSpread_TripleSpread_H
#define __TripleSpread_TripleSpread_H

#include "../../../configuration.h"
#ifdef SHR3D_SFX_CORE_AIRWINDOWS

#include "../common/airwin_consolidated_base.h"


namespace airwinconsolidated::TripleSpread {
enum {
	kParamA = 0,
	kParamB = 1,
	kParamC = 2,
  kNumParameters = 3
}; //


class TripleSpread final : public AirwinConsolidatedBase
{
public:
    TripleSpread();
    ~TripleSpread();
    void processReplacing (float** inputs, float** outputs, VstInt32 sampleFrames) override;
    float getParameter(VstInt32 index) override;
    void setParameter(VstInt32 index, float value) override;
    void getParameterLabel(VstInt32 index, char *text) override;
    void getParameterName(VstInt32 index, char *text) override;
    void getParameterDisplay(VstInt32 index, char *text) override;
private:
    char _programName[kVstMaxProgNameLen + 1];
    
	VstInt32 pL[131076];
	VstInt32 offsetL[258];
	VstInt32 pastzeroL[258];
	VstInt32 previousL[258];
	VstInt32 thirdL[258];
	VstInt32 fourthL[258];
	VstInt32 tempL;
	VstInt32 lasttempL;
	VstInt32 thirdtempL;
	VstInt32 fourthtempL;
	VstInt32 sincezerocrossL;
	int crossesL;
	int realzeroesL;
	double positionL;
	bool splicingL;
	
	double airPrevL;
	double airEvenL;
	double airOddL;
	double airFactorL;
	
	VstInt32 pR[131076];
	VstInt32 offsetR[258];
	VstInt32 pastzeroR[258];
	VstInt32 previousR[258];
	VstInt32 thirdR[258];
	VstInt32 fourthR[258];
	VstInt32 tempR;
	VstInt32 lasttempR;
	VstInt32 thirdtempR;
	VstInt32 fourthtempR;
	VstInt32 sincezerocrossR;
	int crossesR;
	int realzeroesR;
	double positionR;
	bool splicingR;
	
	double airPrevR;
	double airEvenR;
	double airOddR;
	double airFactorR;
	
	int gcount;
	VstInt32 lastwidth;
	bool flip;
	uint32_t fpdL;
	uint32_t fpdR;
	//default stuff

    float A;
    float B;
    float C;

};

} // end namespace

#endif // SHR3D_SFX_CORE_AIRWINDOWS

#endif
