/* ========================================
 *  ZOutputStage - ZOutputStage.h
 *  Created 8/12/11 by SPIAdmin 
 *  Copyright (c) Airwindows, Airwindows uses the MIT license
 * ======================================== */

#ifndef __ZOutputStage_ZOutputStage_H
#define __ZOutputStage_ZOutputStage_H

#include "../../../configuration.h"
#ifdef SHR3D_SFX_CORE_AIRWINDOWS

#include "../common/airwin_consolidated_base.h"


namespace airwinconsolidated::ZOutputStage {
enum {
	kParamA = 0,
	kParamB = 1,
  kNumParameters = 2
}; //


class ZOutputStage final : public AirwinConsolidatedBase
{
public:
    ZOutputStage();
    ~ZOutputStage();
    void processReplacing (float** inputs, float** outputs, VstInt32 sampleFrames) override;
    float getParameter(VstInt32 index) override;
    void setParameter(VstInt32 index, float value) override;
    void getParameterLabel(VstInt32 index, char *text) override;
    void getParameterName(VstInt32 index, char *text) override;
    void getParameterDisplay(VstInt32 index, char *text) override;
private:
    char _programName[kVstMaxProgNameLen + 1];
    
	double biquadE[15];
	double biquadF[15];
	double iirSampleAL;
	double iirSampleAR;

	uint32_t fpdL;
	uint32_t fpdR;
	//default stuff

    float A;
    float B;
};

} // end namespace

#endif // SHR3D_SFX_CORE_AIRWINDOWS

#endif
