// SPDX-License-Identifier: Unlicense

#ifndef SFX_CORE_AIR_WINDOWS_H
#define SFX_CORE_AIR_WINDOWS_H

#include "../../configuration.h"

#ifdef SHR3D_SFX_CORE_AIRWINDOWS

#include <string>

namespace SfxCoreAirWindows
{
  enum AirWindows
  {
    Acceleration,
    Acceleration2,
    ADClip7,
    ADClip8,
    ADT,
    Air,
    Air2,
    Air3,
    Apicolypse,
    AQuickVoiceClip,
    AtmosphereBuss,
    AtmosphereChannel,
    Aura,
    AutoPan,
    Average,
    AverMatrix,
    Balanced,
    BassAmp,
    BassDrive,
    BassKit,
    Baxandall,
    Baxandall2,
    Beam,
    BigAmp,
    Biquad,
    Biquad2,
    BiquadDouble,
    BiquadHiLo,
    BiquadNonLin,
    BiquadOneHalf,
    BiquadPlus,
    BiquadStack,
    BiquadTriple,
    Bite,
    BitGlitter,
    BitShiftGain,
    BitShiftPan,
    BlockParty,
    BrassRider,
    BrightAmbience,
    BrightAmbience2,
    BrightAmbience3,
    BuildATPDF,
    BussColors4,
    ButterComp,
    ButterComp2,
    C5RawBuss,
    C5RawChannel,
    Cabs,
    Calibre,
    Capacitor,
    Capacitor2,
    Chamber,
    Chamber2,
    Channel4,
    Channel5,
    Channel6,
    Channel7,
    Channel8,
    Channel9,
    Chorus,
    ChorusEnsemble,
    ChromeOxide,
    Cider,
    ClearCoat,
    ClipOnly2,
    ClipSoftly,
    CloudCoat,
    Coils,
    Coils2,
    Cojones,
    Compresaturator,
    Console0Buss,
    Console0Channel,
    Console4Buss,
    Console4Channel,
    Console5Buss,
    Console5Channel,
    Console5DarkCh,
    Console6Buss,
    Console6Channel,
    Console7Buss,
    Console7Cascade,
    Console7Channel,
    Console7Crunch,
    Console8BussHype,
    Console8BussIn,
    Console8BussOut,
    Console8ChannelHype,
    Console8ChannelIn,
    Console8ChannelOut,
    Console8LiteBuss,
    Console8LiteChannel,
    Console8SubHype,
    Console8SubIn,
    Console8SubOut,
    Console9Buss,
    Console9Channel,
    ConsoleLABuss,
    ConsoleLAChannel,
    ConsoleMCBuss,
    ConsoleMCChannel,
    ConsoleMDBuss,
    ConsoleMDChannel,
    ConsoleXBuss,
    ConsoleXChannel,
    ContentHideD,
    CreamCoat,
    Creature,
    CrickBass,
    CrunchCoat,
    CrunchyGrooveWear,
    Crystal,
    CStrip,
    CStrip2,
    curve,
    Dark,
    DarkNoise,
    DCVoltage,
    DeBess,
    Deckwrecka,
    DeEss,
    DeHiss,
    Density,
    Density2,
    DeRez,
    DeRez2,
    DeRez3,
    Desk,
    Desk4,
    DigitalBlack,
    Dirt,
    Discontinuity,
    Distance,
    Distance2,
    Distance3,
    Distortion,
    Ditherbox,
    DitherFloat,
    DitherMeDiskers,
    DitherMeTimbers,
    Doublelay,
    DoublePaul,
    Drive,
    DrumSlam,
    DubCenter,
    Dubly,
    DubSub,
    DustBunny,
    Dynamics,
    Dyno,
    Edge,
    EdIsDim,
    Elation,
    ElectroHat,
    Energy,
    Energy2,
    Ensemble,
    EQ,
    EveryConsole,
    EverySlew,
    EveryTrim,
    Exciter,
    Facet,
    FathomFive,
    FinalClip,
    FireAmp,
    Flipity,
    Floor,
    Flutter,
    Focus,
    Fracture,
    Fracture2,
    FromTape,
    Galactic,
    Galactic2,
    GalacticVibe,
    Gatelope,
    GlitchShifter,
    GoldenSlew,
    Golem,
    GrindAmp,
    Gringer,
    GrooveWear,
    GuitarConditioner,
    HardVacuum,
    Hermepass,
    HermeTrim,
    HighGlossDither,
    HighImpact,
    Highpass,
    Highpass2,
    Holt,
    Holt2,
    Hombre,
    Huge,
    Hull,
    Hull2,
    Hype,
    Hypersonic,
    HypersonX,
    Infinity,
    Infinity2,
    Inflamer,
    Infrasonic,
    Interstage,
    IronOxide5,
    IronOxideClassic,
    IronOxideClassic2,
    Isolator,
    Isolator2,
    Kalman,
    kCathedral,
    kCathedral2,
    kCathedral3,
    kChamberAR,
    kGuitarHall,
    kPlate140,
    kPlate240,
    kPlateA,
    kPlateB,
    kPlateC,
    kPlateD,
    LeadAmp,
    LeftoMono,
    LilAmp,
    Logical4,
    Loud,
    Lowpass,
    Lowpass2,
    LRFlipTimer,
    Luxor,
    MackEQ,
    Mackity,
    MatrixVerb,
    Melt,
    MidAmp,
    MidSide,
    Mojo,
    Monitoring,
    Monitoring2,
    Monitoring3,
    MoNoam,
    MSFlipTimer,
    MultiBandDistortion,
    MV,
    MV2,
    NaturalizeDither,
    NCSeventeen,
    Neverland,
    Nikola,
    NodeDither,
    Noise,
    NonlinearSpace,
    NotJustAnotherCD,
    NotJustAnotherDither,
    OneCornerClip,
    OrbitKick,
    Overheads,
    Pafnuty,
    Pafnuty2,
    Parametric,
    PaulDither,
    PaulWide,
    PDBuss,
    PDChannel,
    PeaksOnly,
    Pear,
    Pear2,
    PhaseNudge,
    PitchDelay,
    PitchNasty,
    PlatinumSlew,
    PocketVerbs,
    Pockey,
    Pockey2,
    Podcast,
    PodcastDeluxe,
    Point,
    Pop,
    Pop2,
    Pop3,
    PowerSag,
    PowerSag2,
    Precious,
    Preponderant,
    Pressure4,
    Pressure5,
    PurestAir,
    PurestConsole2Buss,
    PurestConsole2Channel,
    PurestConsole3Buss,
    PurestConsole3Channel,
    PurestConsoleBuss,
    PurestConsoleChannel,
    PurestDrive,
    PurestEcho,
    PurestFade,
    PurestGain,
    PurestSquish,
    PurestWarm,
    PurestWarm2,
    Pyewacket,
    RawGlitters,
    RawTimbers,
    Recurve,
    Remap,
    ResEQ,
    ResEQ2,
    Reverb,
    Righteous4,
    RightoMono,
    SampleDelay,
    Shape,
    ShortBuss,
    SideDull,
    Sidepass,
    Silhouette,
    Sinew,
    SingleEndedTriode,
    Slew,
    Slew2,
    Slew3,
    SlewOnly,
    SlewSonic,
    Smooth,
    SoftGate,
    SpatializeDither,
    Spiral,
    Spiral2,
    Srsly,
    Srsly2,
    Srsly3,
    StarChild,
    StarChild2,
    StereoChorus,
    StereoDoubler,
    StereoEnsemble,
    StereoFX,
    Stonefire,
    StoneFireComp,
    StudioTan,
    SubsOnly,
    SubTight,
    Surge,
    SurgeTide,
    Sweeten,
    Swell,
    Tape,
    TapeDelay,
    TapeDelay2,
    TapeDither,
    TapeDust,
    TapeFat,
    Texturize,
    TexturizeMS,
    Thunder,
    ToneSlant,
    ToTape5,
    ToTape6,
    ToVinyl4,
    TPDFDither,
    TPDFWide,
    TransDesk,
    Tremolo,
    TremoSquare,
    Trianglizer,
    TripleSpread,
    Tube,
    Tube2,
    TubeDesk,
    uLawDecode,
    uLawEncode,
    Ultrasonic,
    UltrasonicLite,
    UltrasonicMed,
    UltrasonX,
    UnBox,
    VariMu,
    Verbity,
    Verbity2,
    Vibrato,
    VinylDither,
    VoiceOfTheStarship,
    VoiceTrick,
    Weight,
    Wider,
    Wolfbot,
    XBandpass,
    XHighpass,
    XLowpass,
    XNotch,
    XRegion,
    YBandpass,
    YHighpass,
    YLowpass,
    YNotBandpass,
    YNotch,
    YNotHighpass,
    YNotLowpass,
    YNotNotch,
    ZBandpass,
    ZBandpass2,
    ZHighpass,
    ZHighpass2,
    ZLowpass,
    ZLowpass2,
    ZNotch,
    ZNotch2,
    ZOutputStage,
    ZRegion,
    ZRegion2,
    COUNT
  };

  void loadParameters(AirWindows airWindow, int instance, const float* params, int paramCount);
  std::u8string saveParameters(AirWindows airWindow, int instance);
  void processReplacing(AirWindows airWindow, int instance, float** inBlock, float** outBlock, int blockSize);


  int getParameterCount(AirWindows airWindow);
  float getParameter(AirWindows airWindow, int instance, int param);
  void setParameter(AirWindows airWindow, int instance, int param, float value);
  void getParameterLabel(AirWindows airWindow, int instance, int param, char* text);
  void getParameterName(AirWindows airWindow, int instance, int param, char* text);
  void getParameterDisplay(AirWindows airWindow, int instance, int param, char* text);

  //void fixOrder(AirWindows airWindow, int instance, int instance2);
}

#endif // SHR3D_SFX_CORE_AIRWINDOWS

#endif // SFX_CORE_AIR_WINDOWS_H
