/*
  ZynAddSubFX - a software synthesizer

  Filter_.h - This class is inherited by filter classes
  Copyright (C) 2002-2005 Nasca Octavian Paul
  Author: Nasca Octavian Paul

  Modified for rakarrack by Josep Andreu

  This program is free software; you can redistribute it and/or modify
  it under the terms of version 2 of the GNU General Public License
  as published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License (version 2) for more details.

  You should have received a copy of the GNU General Public License (version 2)
  along with this program; if not, write to the Free Software Foundation,
  Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

*/

#ifndef FILTER__H
#define FILTER__H

#include "../../../typedefs.h"

#ifdef SHR3D_SFX_CORE_RAKARRACK

struct FilterBase
{
  virtual void filterout(f32* smp, const i32 blockSize) = 0;
  virtual void setfreq(f32 frequency) = 0;
  virtual void setfreq_and_q(f32 frequency, f32 q_) = 0;
  virtual void setq(f32 q_) = 0;
  virtual void setgain(f32 dBgain) = 0;
  f32 outgain;
};

#endif // SHR3D_SFX_CORE_RAKARRACK

#endif
