#ifndef GLOBAL__H
#define GLOBAL__H

#include "../../../global.h"

#ifdef SHR3D_SFX_CORE_RAKARRACK

#define D_PI 6.283185f
//#define PI 3.141598f
#define M_PI_2 1.57079632679489661923
#define LOG_10 2.302585f
#define LOG_2  0.693147f
#define LN2R 1.442695041f
#define CNST_E  2.71828182845905f
#define MAX_FILTER_STAGES 5
#define SAMPLE_RATE 48000
#define fSAMPLE_RATE 48000.0f
#define cSAMPLE_RATE (1.0f / 48000.0f)
#define DENORMAL_GUARD 1e-18f	// Make it smaller until CPU problem re-appears
#define PERIOD 128
#define fPERIOD 128.0f
#define Thi 0.67f			//High threshold for limiting onset
#define Tlo -0.65f			//Low threshold for limiting onset
#define Tlc -0.6139445f		//Tlo + sqrt(Tlo/500)
#define Thc 0.6365834f	        //Thi - sqrt(Thi/600)
#define CRUNCH_GAIN	100.0f			//Typical voltage gain for most OD stompboxes
#define DIV_TLC_CONST 0.002f			// 1/300
#define DIV_THC_CONST	0.0016666f		// 1/600 (approximately)
#define RND (rand()/(RAND_MAX+1.0))
#define RND1 (((f32) rand())/(((f32) RAND_MAX)+1.0f))
#define F2I(f,i) (i)=((f>0) ? ( (i32)(f) ) :( (i32)(f-1.0f) ))
#define dB2rap(dB) (f32)((expf((dB)*LOG_10/20.0f)))
#define rap2dB(rap) (f32)((20*log(rap)/LOG_10))
#define CLAMP(x, low, high)  (((x) > (high)) ? (high) : (((x) < (low)) ? (low) : (x)))
#define INTERPOLATE_AMPLITUDE(a,b,x,size) ( (a) + ( (b) - (a) ) * (f32)(x) / (f32) (size) )
#define AMPLITUDE_INTERPOLATION_THRESHOLD 0.0001f
#define ABOVE_AMPLITUDE_THRESHOLD(a,b) ( ( 2.0f*fabs( (b) - (a) ) / ( fabs( (b) + (a) + 0.0000000001f) ) ) > AMPLITUDE_INTERPOLATION_THRESHOLD )
#define D_FLANGE_MAX_DELAY	0.055f			// Number of Seconds  - 50ms corresponds to fdepth = 20 (Hz). Added some extra for padding
#define MAX_ALIENWAH_DELAY 100
#define REV_COMBS 8
#define REV_APS 4
#define ATTACK 0.175f  //crossover time for reverse delay
#define MAX_DELAY 2	// Number of Seconds
#define MAX_CHORUS_DELAY 250.0f	//ms
#define MAX_EQ_BANDS 16
#define CLOSED 1
#define OPENING 2
#define OPEN 3
#define CLOSING 4
#define ENV_TR 0.0001f
#define HARMONICS 11
#define MAX_PHASER_STAGES 12
#define MAX_SFILTER_STAGES 12
#define FF_MAX_VOWELS 6
#define FF_MAX_FORMANTS 12
#define FF_MAX_SEQUENCE 8
#define MAXHARMS  8    // max number of harmonics available


inline i32 Wave_res_amount = 2;
inline i32 Wave_up_q = 4;
inline i32 Wave_down_q = 2;
inline i32 pdata[50];
inline f32 r__ratio[12];
inline i32 maxx_len = 100;

#endif // SHR3D_SFX_CORE_RAKARRACK

#endif // GLOBAL__H