/*
  ZynAddSubFX - a software synthesizer

  Looper.h - Looper Effect
  Copyright (C) 2002-2005 Nasca Octavian Paul
  Author: Nasca Octavian Paul

  Modified for rakarrack by Ryan Billing & Josep Andreu
  Reverse Echo by Transmogrifox

  This program is free software; you can redistribute it and/or modify
  it under the terms of version 2 of the GNU General Public License
  as published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License (version 2) for more details.

  You should have received a copy of the GNU General Public License (version 2)
  along with this program; if not, write to the Free Software Foundation,
  Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

*/

#ifndef LOOPER_H
#define LOOPER_H

#include "../../../typedefs.h"

#ifdef SHR3D_SFX_CORE_RAKARRACK

#if 0

#include "../common/Global.h"
#include "../common/Metronome.h"

class Looper
{
public:
  Looper(f32 size = 0.5f);
  void processBlock(const f32* const* inBlock, f32** outBlock, i32 blockSize);
  void setpreset(i32 npreset);
  void loadpreset(i32 npar, i32 value);  // to set one from a preset
  void changepar(i32 npar, i32 value);
  i32 getpar(i32 npar);
  void cleanuppt1();
  void cleanuppt2();
  void cleanup();
  void settempo(i32 value);
  void setmvol(i32 value);
  i32 looper_bar;
  i32 looper_qua;
  i32 progstate[6];

  void getstate();

  f32 outvolume;

  i32 Pplay = 0;	//set to 1
  i32 Pstop = 1;	//set to 1

private:

  void initdelays();
  void setfade();
  void setbar(i32 value);
  void timeposition(i32 value);
  i32 set_len(i32 value);
  i32 cal_len(i32 value);

  //Parameters
  i32 Pvolume;	//Mix
  i32 Precord = 0;	//set to 1
  i32 Pclear = 1;   //set to 1
  i32 Preverse;	//0 or 1
  i32 Pfade1;    //0...127//  crossfade track1 & 2
  i32 Pfade2;
  i32 PT1 = 1;
  i32 PT2 = 0;
  i32 Pautoplay = 0;
  i32 Prec1;
  i32 Prec2;
  i32 Plink;
  i32 Ptempo = 120;
  i32 Pbar = 2;
  i32 Pmetro;
  i32 Pms = 0;

  i32 kl, kl2, rvkl, rvkl2, maxx_delay, fade, dl, dl2, first_time1 = 1, first_time2 = 1, rplaystate = 0;
  i32 barlen, looper_ts;

  f32* ldelay, * rdelay;
  f32* t2ldelay, * t2rdelay;

  f32 oldl, oldr;		//pt. lpf

  f32 Srate_Attack_Coeff, track1gain, track2gain, fade1, fade2, pregain1, pregain2;
  f32 mvol;

  Metronome ticker;
};

#endif

#endif // SHR3D_SFX_CORE_RAKARRACK

#endif
