// SPDX-License-Identifier: Unlicense

#ifndef SFXPLUGINLV2_H
#define SFXPLUGINLV2_H

#include "configuration.h"

#ifdef SHR3D_SFX_PLUGIN_LV2

#include "type.h"

#include <string>

namespace SfxPluginLv2
{
  void init();

  void openWindow(i32 index, i32 instance);
  Rect getWindowSize(i32 index);
  void moveWindow(i32 index, i32 x, i32 y);
  void closeWindow(i32 index, i32 instance);

  void processBlock(i32 index, i32 instance, f32** inBlock, f32** outBlock, i32 blockSize);

  std::string saveParameters(i32 index, i32 instance);
  void loadParameters(i32 index, i32 instance, const std::string& parameters);
}

#endif // SHR3D_SFX_PLUGIN_LV2

#endif // SFXPLUGINLV2_H
