// SPDX-License-Identifier: Unlicense

#ifndef SFXPLUGINVST_H
#define SFXPLUGINVST_H

#include "configuration.h"

#ifdef SHR3D_SFX_PLUGIN_VST

#include "type.h"

#include <string>

namespace SfxPluginVst
{
  void init(std::vector<std::u8string>& sfxNames);

#ifdef SHR3D_SFX_PLUGIN_GUI_WINDOW
  bool hasWindow(i32 index);
  void openWindow(i32 index, i32 instance);
  Size getWindowSize(i32 index);
  void moveWindow(i32 index, i32 x, i32 y);
  void closeWindow(i32 index, i32 instance);
#endif // SHR3D_SFX_PLUGIN_GUI_WINDOW

  i32 numParams(i32 index, i32 instance);
  void getParameterProperties(i32 index, i32 instance, i32 param, SfxParameterProperties& parameterProperties);
  f32 getParameter(i32 index, i32 instance, i32 param);
  void setParameter(i32 index, i32 instance, i32 param, f32 value);

  void processBlock(i32 index, i32 instance, f32** inBlock, f32** outBlock, i32 blockSize);

  std::u8string saveParameters(i32 index, i32 instance);
  void loadParameters(i32 index, i32 instance, const std::u8string& parameters);

  void setMidiFromAudioCallback(i32 index, i32 instance, bool enabled);
}

#endif // SHR3D_SFX_PLUGIN_VST

#endif // SFXPLUGINVST_H
