// SPDX-License-Identifier: Unlicense

#ifndef SFXPLUGINVST3_H
#define SFXPLUGINVST3_H

#include "configuration.h"

#ifdef SHR3D_SFX_PLUGIN_VST3

#include "type.h"

#include <string>

namespace SfxPluginVst3
{
  void init(std::vector<std::u8string>& sfxNames);

  void openWindow(i32 index, i32 instance);
  Size getWindowSize(i32 index);
  void moveWindow(i32 index, i32 x, i32 y);
  void closeWindow(i32 index);

  void processBlock(i32 index, i32 instance, f32** inBlock, f32** outBlock, i32 blockSize);

  std::u8string saveParameters(i32 index, i32 instance);
  void loadParameters(i32 index, i32 instance, const std::u8string& parameters);
}

#endif // SHR3D_SFX_PLUGIN_VST3

#endif // SFXPLUGINVST3_H
